unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,
  jwadbt, jwaioevent, jwawinioctl, jwawinbase;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Bevel1: TBevel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Memo1: TMemo;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Edit1Change(Sender: TObject);
  private
    procedure WMDeviceChange(var Msg: TWMDeviceChange); message WM_DeviceChange;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  Filter: TDevBroadcastHandle;
  Notify: HDEVNOTIFY;

function GetFirstPhysicalDriveNumber(DrvChar: Char): Integer;
var
  i: Cardinal;
  Buf: packed array[0..256]of Char;
  DriveName: String;
begin
  Result := -1;
  QueryDosDevice(PChar(''+DrvChar+':'), Buf, 256);
  DriveName := AnsiLowerCase(StrPas(Buf));
  Form1.Memo1.Lines.Add( 'Drive '+DrvChar+': is a '+Buf );
  i := Pos('\device\harddisk', DriveName);
  if i = 1 then begin
    Delete(DriveName,1,Length('\device\harddisk'));
    i := Pos('\',DriveName);
    if i > 0 then
      Delete(DriveName, i, MAXINT);
    try
      Result := StrToInt(DriveName);
    except
    end;
    end;
end;

function MyRegisterNotification( Wnd: HWND; DriveChar: Char; var Fltr: TDevBroadcastHandle): HDEVNOTIFY;
var
  PhysDrvH: THandle;
  PhysDrvName: String;
  PhysDrvNum: Integer;
begin
  Result := nil;
  FillChar(Fltr, SizeOf(Fltr), 0);
  PhysDrvNum := GetFirstPhysicalDriveNumber(DriveChar);
  Form1.Memo1.Lines.Add( 'Physical drive number is '+IntToStr(PhysDrvNum) );
  if PhysDrvNum = -1 then Exit;
  PhysDrvName := '\\.\PhysicalDrive'+IntToStr(PhysDrvNum);
  PhysDrvH := CreateFile(PChar(PhysDrvName),0,FILE_SHARE_WRITE, nil,OPEN_EXISTING,0,0);
  Form1.Memo1.Lines.Add( 'Physical drive opened. Handle is '+IntToStr(PhysDrvH) );
  Form1.Label4.Caption := '[in] dbch_handle = '+IntToStr(PhysDrvH);

  Fltr.dbch_size:=SizeOf(Fltr);
  Fltr.dbch_devicetype := DBT_DEVTYP_HANDLE;

  Fltr.dbch_handle := PhysDrvH;

  Result := RegisterDeviceNotification(Wnd,@Fltr,DEVICE_NOTIFY_WINDOW_HANDLE);
  Form1.Memo1.Lines.Add( 'Notification registered. Handle is '+IntToStr(DWord(Result)) );
  Form1.Memo1.Lines.Add( 'Physical drive closed.' );
  Form1.Memo1.Lines.Add( '-----------------------------------------');
  CloseHandle(PhysDrvH);
end;

procedure TForm1.WMDeviceChange(var Msg: TWMDeviceChange);
begin
  if (Msg.Event = DBT_CUSTOMEVENT) then
    with PDevBroadcastHandle(Msg.dwData)^ do begin
      if (dbch_devicetype=DBT_DEVTYP_HANDLE) then begin
        if IsEqualGUID(dbch_eventguid,GUID_IO_MEDIA_ARRIVAL) then begin
           Label1.Caption := 'Inserted';
           Label5.Caption := '[rcv] dbch_handle = '+IntToStr(dbch_handle);
           Form1.Memo1.Lines.Add( 'Drive INSERTED');
           Form1.Memo1.Lines.Add( '[rcv] dbch_handle = '+IntToStr(dbch_handle));
           Form1.Memo1.Lines.Add( '[rcv] dbch_hdevnotify = '+IntToStr(DWord(dbch_hdevnotify)));
           Form1.Memo1.Lines.Add( '[rcv] dbch_nameoffset = '+IntToStr(dbch_nameoffset));
           Form1.Memo1.Lines.Add( '-----------------------------------------');
           end
        else if IsEqualGUID(dbch_eventguid,GUID_IO_MEDIA_REMOVAL) then begin
           Label1.Caption := 'Removed';
           Label5.Caption := '[rcv] dbch_handle = '+IntToStr(dbch_handle);
           Form1.Memo1.Lines.Add( 'Drive REMOVED');
           Form1.Memo1.Lines.Add( '[rcv] dbch_handle = '+IntToStr(dbch_handle));
           Form1.Memo1.Lines.Add( '[rcv] dbch_hdevnotify = '+IntToStr(DWord(dbch_hdevnotify)));
           Form1.Memo1.Lines.Add( '[rcv] dbch_nameoffset = '+IntToStr(dbch_nameoffset));
           Form1.Memo1.Lines.Add( '-----------------------------------------');
           end;
        end;
      end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  UnregisterDeviceNotification(Notify);
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  Form1.Memo1.Lines.Add( '=========================================');
  if Notify <> nil then begin
    UnregisterDeviceNotification(Notify);
    Notify := nil;
    end;
  Label1.Caption := '-----';
  if Length(Edit1.Text) > 0 then
    Notify := MyRegisterNotification( Handle, Edit1.Text[1], Filter);
  Label3.Caption := 'Notify Handle: '+IntToStr(DWord(Notify));
end;

end.

